Index: serefpolicy-contrib-20140730/pulseaudio.if
===================================================================
--- serefpolicy-contrib-20140730.orig/pulseaudio.if
+++ serefpolicy-contrib-20140730/pulseaudio.if
@@ -2,43 +2,48 @@
 
 ########################################
 ## <summary>
-##	Role access for pulseaudio.
+##	Role access for pulseaudio
 ## </summary>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	Role allowed access
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	User domain for the role
 ##	</summary>
 ## </param>
 #
 interface(`pulseaudio_role',`
 	gen_require(`
-		attribute pulseaudio_tmpfsfile;
-		type pulseaudio_t, pulseaudio_home_t, pulseaudio_tmpfs_t;
-		type pulseaudio_tmp_t;
+        attribute pulseaudio_tmpfsfile;
+		type pulseaudio_t, pulseaudio_exec_t, pulseaudio_tmpfs_t;
+		class dbus { acquire_svc send_msg };
 	')
 
-	pulseaudio_run($2, $1)
+	role $1 types pulseaudio_t;
+
+	# Transition from the user domain to the derived domain.
+	domtrans_pattern($2, pulseaudio_exec_t, pulseaudio_t)
 
-	allow $2 pulseaudio_t:process { ptrace signal_perms };
 	ps_process_pattern($2, pulseaudio_t)
 
-	allow $2 pulseaudio_home_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 pulseaudio_home_t:file { manage_file_perms relabel_file_perms };
-	allow $2 pulseaudio_home_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
+	allow pulseaudio_t $2:process { signal signull };
+	allow $2 pulseaudio_t:process { signal signull sigkill };
+	ps_process_pattern(pulseaudio_t, $2)
+
+	allow pulseaudio_t $2:unix_stream_socket connectto;
+	allow $2 pulseaudio_t:unix_stream_socket connectto;
 
 	allow $2 { pulseaudio_tmpfs_t pulseaudio_tmpfsfile }:dir { manage_dir_perms relabel_dir_perms };
 	allow $2 { pulseaudio_tmpfs_t pulseaudio_tmpfsfile }:file { manage_file_perms relabel_file_perms };
 
-	allow $2 pulseaudio_tmp_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 pulseaudio_tmp_t:file { manage_file_perms relabel_file_perms };
-	allow $2 pulseaudio_tmp_t:sock_file { manage_sock_file_perms relabel_sock_file_perms };
+	userdom_manage_tmp_role($1, pulseaudio_t)
+	userdom_manage_tmpfs_role($1, pulseaudio_t)
 
-	allow pulseaudio_t $2:unix_stream_socket connectto;
+	allow $2 pulseaudio_t:dbus send_msg;
+	allow pulseaudio_t $2:dbus { acquire_svc send_msg };
 ')
 
 ########################################
@@ -65,9 +70,8 @@ interface(`pulseaudio_domtrans',`
 
 ########################################
 ## <summary>
-##	Execute pulseaudio in the pulseaudio
-##	domain, and allow the specified role
-##	the pulseaudio domain.
+##	Execute pulseaudio in the pulseaudio domain, and
+##	allow the specified role the pulseaudio domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -82,16 +86,16 @@ interface(`pulseaudio_domtrans',`
 #
 interface(`pulseaudio_run',`
 	gen_require(`
-		attribute_role pulseaudio_roles;
+		type pulseaudio_t;
 	')
 
 	pulseaudio_domtrans($1)
-	roleattribute $2 pulseaudio_roles;
+	role $2 types pulseaudio_t;
 ')
 
 ########################################
 ## <summary>
-##	Execute pulseaudio in the caller domain.
+##	Execute a pulseaudio in the current domain.
 ## </summary>
 ## <param name="domain">
 ## <summary>
@@ -104,13 +108,12 @@ interface(`pulseaudio_exec',`
 		type pulseaudio_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, pulseaudio_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to execute pulseaudio.
+##	Do not audit to execute a pulseaudio.
 ## </summary>
 ## <param name="domain">
 ## <summary>
@@ -128,7 +131,7 @@ interface(`pulseaudio_dontaudit_exec',`
 
 ########################################
 ## <summary>
-##	Send null signals to pulseaudio.
+##	Send signull signal to pulseaudio
 ##	processes.
 ## </summary>
 ## <param name="domain">
@@ -147,8 +150,8 @@ interface(`pulseaudio_signull',`
 
 #####################################
 ## <summary>
-##	Connect to pulseaudio with a unix
-##	domain stream socket.
+##	Connect to pulseaudio over a unix domain
+##	stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -158,11 +161,15 @@ interface(`pulseaudio_signull',`
 #
 interface(`pulseaudio_stream_connect',`
 	gen_require(`
-		type pulseaudio_t, pulseaudio_var_run_t, pulseaudio_tmp_t;
+		type pulseaudio_t, pulseaudio_var_run_t;
+		type pulseaudio_home_t;
 	')
 
 	files_search_pids($1)
-	stream_connect_pattern($1, { pulseaudio_tmp_t pulseaudio_var_run_t }, { pulseaudio_tmp_t pulseaudio_var_run_t }, pulseaudio_t)
+	allow $1 pulseaudio_t:process signull;
+	allow pulseaudio_t $1:process signull;
+	stream_connect_pattern($1, pulseaudio_var_run_t, pulseaudio_var_run_t, pulseaudio_t)
+	stream_connect_pattern($1, pulseaudio_home_t, pulseaudio_home_t, pulseaudio_t)
 ')
 
 ########################################
@@ -188,9 +195,9 @@ interface(`pulseaudio_dbus_chat',`
 
 ########################################
 ## <summary>
-##	Set attributes of pulseaudio home directories.
+##	Set the attributes of the pulseaudio homedir.
 ## </summary>
-## <param name="domain">
+## <param name="user_domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
@@ -201,148 +208,190 @@ interface(`pulseaudio_setattr_home_dir',
 		type pulseaudio_home_t;
 	')
 
-	allow $1 pulseaudio_home_t:dir setattr_dir_perms;
+	allow $1 pulseaudio_home_t:dir setattr;
 ')
 
 ########################################
 ## <summary>
-##	Read pulseaudio home content.
+##	Read pulseaudio homedir files.
 ## </summary>
-## <param name="domain">
+## <param name="user_domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
 interface(`pulseaudio_read_home_files',`
-	refpolicywarn(`$0($*) has been deprecated, use pulseaudio_read_home() instead.')
-	pulseaudio_read_home($1)
+	gen_require(`
+		type pulseaudio_home_t;
+	')
+
+	userdom_search_user_home_dirs($1)
+	read_files_pattern($1, pulseaudio_home_t, pulseaudio_home_t)
+	read_lnk_files_pattern($1, pulseaudio_home_t, pulseaudio_home_t)
 ')
 
 ########################################
 ## <summary>
-##	Read pulseaudio home content.
+##	Read and write Pulse Audio files.
 ## </summary>
-## <param name="domain">
+## <param name="user_domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`pulseaudio_read_home',`
+interface(`pulseaudio_rw_home_files',`
 	gen_require(`
 		type pulseaudio_home_t;
 	')
 
+	rw_files_pattern($1, pulseaudio_home_t, pulseaudio_home_t)
+	read_lnk_files_pattern($1, pulseaudio_home_t, pulseaudio_home_t)
 	userdom_search_user_home_dirs($1)
-	allow $1 pulseaudio_home_t:dir list_dir_perms;
-	allow $1 pulseaudio_home_t:file read_file_perms;
-	allow $1 pulseaudio_home_t:lnk_file read_lnk_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read and write Pulse Audio files.
+##	Create, read, write, and delete pulseaudio
+##	home directories.
 ## </summary>
-## <param name="domain">
+## <param name="user_domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`pulseaudio_rw_home_files',`
+interface(`pulseaudio_manage_home_dirs',`
 	gen_require(`
 		type pulseaudio_home_t;
 	')
 
 	userdom_search_user_home_dirs($1)
-	rw_files_pattern($1, pulseaudio_home_t, pulseaudio_home_t)
-	read_lnk_files_pattern($1, pulseaudio_home_t, pulseaudio_home_t)
+	manage_dirs_pattern($1, pulseaudio_home_t, pulseaudio_home_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	pulseaudio home content.
+##	Create, read, write, and delete pulseaudio
+##	home directory files.
 ## </summary>
-## <param name="domain">
+## <param name="user_domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
 interface(`pulseaudio_manage_home_files',`
-	refpolicywarn(`$0($*) has been deprecated, use pulseaudio_manage_home() instead.')
-	pulseaudio_manage_home($1)
+	gen_require(`
+		type pulseaudio_home_t;
+	')
+
+	userdom_search_user_home_dirs($1)
+	manage_files_pattern($1, pulseaudio_home_t, pulseaudio_home_t)
+	read_lnk_files_pattern($1, pulseaudio_home_t, pulseaudio_home_t)
+	pulseaudio_filetrans_home_content($1)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	pulseaudio home content.
+##	Create, read, write, and delete pulseaudio
+##	home directory symlinks.
 ## </summary>
-## <param name="domain">
+## <param name="user_domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`pulseaudio_manage_home',`
+interface(`pulseaudio_manage_home_symlinks',`
 	gen_require(`
 		type pulseaudio_home_t;
 	')
 
 	userdom_search_user_home_dirs($1)
-	allow $1 pulseaudio_home_t:dir manage_dir_perms;
-	allow $1 pulseaudio_home_t:file manage_file_perms;
-	allow $1 pulseaudio_home_t:lnk_file manage_lnk_file_perms;
+	manage_lnk_files_pattern($1, pulseaudio_home_t, pulseaudio_home_t)
 ')
 
 ########################################
 ## <summary>
-##	Create objects in user home
-##	directories with the pulseaudio
-##	home type.
+##	Create pulseaudio content in the user home directory
+##	with an correct label.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
+#
+interface(`pulseaudio_filetrans_home_content',`
+	gen_require(`
+		type pulseaudio_home_t;
+	')
+
+	userdom_user_home_dir_filetrans($1, pulseaudio_home_t, dir, ".pulse")
+	userdom_user_home_dir_filetrans($1, pulseaudio_home_t, file, ".pulse-cookie")
+	userdom_user_home_dir_filetrans($1, pulseaudio_home_t, file, ".esd_auth")
+	optional_policy(`
+		gnome_config_filetrans($1, pulseaudio_home_t, dir, "pulse")
+	')
+')
+
+########################################
+## <summary>
+##	Create pulseaudio content in the admin home directory
+##	with an correct label.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	The name of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`pulseaudio_home_filetrans_pulseaudio_home',`
+interface(`pulseaudio_filetrans_admin_home_content',`
 	gen_require(`
 		type pulseaudio_home_t;
 	')
 
-	userdom_user_home_dir_filetrans($1, pulseaudio_home_t, $2, $3)
+	userdom_admin_home_dir_filetrans($1, pulseaudio_home_t, dir, ".pulse")
+	userdom_admin_home_dir_filetrans($1, pulseaudio_home_t, file, ".pulse-cookie")
+	userdom_admin_home_dir_filetrans($1, pulseaudio_home_t, file, ".esd_auth")
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Make the specified tmpfs file type
-##	pulseaudio tmpfs content.
+##  Make the specified tmpfs file type
+##  pulseaudio tmpfs content.
 ## </summary>
 ## <param name="file_type">
+##  <summary>
+##  File type to make pulseaudio tmpfs content.
+##  </summary>
+## </param>
+#
+interface(`pulseaudio_tmpfs_content',`
+    gen_require(`
+        attribute pulseaudio_tmpfsfile;
+    ')
+
+    typeattribute $1 pulseaudio_tmpfsfile;
+')
+
+########################################
+## <summary>
+##	Allow the domain to read pulseaudio state files in /proc.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	File type to make pulseaudio tmpfs content.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`pulseaudio_tmpfs_content',`
+interface(`pulseaudio_read_state',`
 	gen_require(`
-		attribute pulseaudio_tmpfsfile;
+		type pulseaudio_t;
 	')
 
-	typeattribute $1 pulseaudio_tmpfsfile;
+	kernel_search_proc($1)
+	ps_process_pattern($1, pulseaudio_t)
 ')
Index: serefpolicy-contrib-20140730/pulseaudio.te
===================================================================
--- serefpolicy-contrib-20140730.orig/pulseaudio.te
+++ serefpolicy-contrib-20140730/pulseaudio.te
@@ -1,4 +1,4 @@
-policy_module(pulseaudio, 1.7.0)
+policy_module(pulseaudio, 1.6.0)
 
 ########################################
 #
@@ -8,61 +8,49 @@ policy_module(pulseaudio, 1.7.0)
 attribute pulseaudio_client;
 attribute pulseaudio_tmpfsfile;
 
-attribute_role pulseaudio_roles;
-
 type pulseaudio_t;
 type pulseaudio_exec_t;
 # init_daemon_domain(pulseaudio_t, pulseaudio_exec_t)
 userdom_user_application_domain(pulseaudio_t, pulseaudio_exec_t)
-role pulseaudio_roles types pulseaudio_t;
+role system_r types pulseaudio_t;
 
 type pulseaudio_home_t;
 userdom_user_home_content(pulseaudio_home_t)
 
-type pulseaudio_tmp_t;
-userdom_user_tmp_file(pulseaudio_tmp_t)
-
 type pulseaudio_tmpfs_t;
 userdom_user_tmpfs_file(pulseaudio_tmpfs_t)
 
 type pulseaudio_var_lib_t;
 files_type(pulseaudio_var_lib_t)
+ubac_constrained(pulseaudio_var_lib_t)
 
 type pulseaudio_var_run_t;
 files_pid_file(pulseaudio_var_run_t)
+ubac_constrained(pulseaudio_var_run_t)
 
 ########################################
 #
-# Local policy
+# pulseaudio local policy
 #
 
 allow pulseaudio_t self:capability { fowner fsetid chown setgid setuid sys_nice sys_resource sys_tty_config };
 allow pulseaudio_t self:process { getcap setcap setrlimit setsched getsched signal signull };
-allow pulseaudio_t self:fifo_file rw_fifo_file_perms;
-allow pulseaudio_t self:unix_stream_socket { accept connectto listen };
-allow pulseaudio_t self:unix_dgram_socket sendto;
-allow pulseaudio_t self:tcp_socket { accept listen };
+allow pulseaudio_t self:fifo_file rw_file_perms;
+allow pulseaudio_t self:unix_stream_socket { create_stream_socket_perms connectto };
+allow pulseaudio_t self:unix_dgram_socket { sendto create_socket_perms };
+allow pulseaudio_t self:tcp_socket create_stream_socket_perms;
+allow pulseaudio_t self:udp_socket create_socket_perms;
 allow pulseaudio_t self:netlink_kobject_uevent_socket create_socket_perms;
 
-allow pulseaudio_t pulseaudio_home_t:dir manage_dir_perms;
-allow pulseaudio_t pulseaudio_home_t:file manage_file_perms;
-allow pulseaudio_t pulseaudio_home_t:lnk_file manage_lnk_file_perms;
-
-userdom_user_home_dir_filetrans(pulseaudio_t, pulseaudio_home_t, dir, ".pulse")
-userdom_user_home_dir_filetrans(pulseaudio_t, pulseaudio_home_t, file, ".esd_auth")
-userdom_user_home_dir_filetrans(pulseaudio_t, pulseaudio_home_t, file, ".pulse-cookie")
-
-manage_dirs_pattern(pulseaudio_t, pulseaudio_tmp_t, pulseaudio_tmp_t)
-manage_files_pattern(pulseaudio_t, pulseaudio_tmp_t, pulseaudio_tmp_t)
-manage_sock_files_pattern(pulseaudio_t, pulseaudio_tmp_t, pulseaudio_tmp_t)
-files_tmp_filetrans(pulseaudio_t, pulseaudio_tmp_t, dir)
-userdom_user_tmp_filetrans(pulseaudio_t, pulseaudio_tmp_t, file, "pid")
-userdom_user_tmp_filetrans(pulseaudio_t, pulseaudio_tmp_t, sock_file, "dbus-socket")
-userdom_user_tmp_filetrans(pulseaudio_t, pulseaudio_tmp_t, sock_file, "native")
-
-manage_dirs_pattern(pulseaudio_t, pulseaudio_tmpfs_t, pulseaudio_tmpfs_t)
-manage_files_pattern(pulseaudio_t, pulseaudio_tmpfs_t, pulseaudio_tmpfs_t)
-fs_tmpfs_filetrans(pulseaudio_t, pulseaudio_tmpfs_t, { dir file })
+manage_dirs_pattern(pulseaudio_t, pulseaudio_home_t, pulseaudio_home_t)
+manage_files_pattern(pulseaudio_t, pulseaudio_home_t, pulseaudio_home_t)
+manage_lnk_files_pattern(pulseaudio_t, pulseaudio_home_t, pulseaudio_home_t)
+userdom_search_user_home_dirs(pulseaudio_t)
+pulseaudio_filetrans_home_content(pulseaudio_t)
+
+# ~/.esd_auth - maybe we should label this pulseaudio_home_t?
+userdom_read_user_home_content_files(pulseaudio_t)
+userdom_search_admin_dir(pulseaudio_t)
 
 manage_dirs_pattern(pulseaudio_t, pulseaudio_var_lib_t, pulseaudio_var_lib_t)
 manage_files_pattern(pulseaudio_t, pulseaudio_var_lib_t, pulseaudio_var_lib_t)
@@ -72,10 +60,7 @@ files_var_lib_filetrans(pulseaudio_t, pu
 manage_dirs_pattern(pulseaudio_t, pulseaudio_var_run_t, pulseaudio_var_run_t)
 manage_files_pattern(pulseaudio_t, pulseaudio_var_run_t, pulseaudio_var_run_t)
 manage_sock_files_pattern(pulseaudio_t, pulseaudio_var_run_t, pulseaudio_var_run_t)
-files_pid_filetrans(pulseaudio_t, pulseaudio_var_run_t, { dir file })
-
-allow pulseaudio_t pulseaudio_client:process signull;
-ps_process_pattern(pulseaudio_t, pulseaudio_client)
+files_pid_filetrans(pulseaudio_t, pulseaudio_var_run_t, { file dir })
 
 can_exec(pulseaudio_t, pulseaudio_exec_t)
 
@@ -85,62 +70,56 @@ kernel_read_kernel_sysctls(pulseaudio_t)
 
 corecmd_exec_bin(pulseaudio_t)
 
-corenet_all_recvfrom_unlabeled(pulseaudio_t)
 corenet_all_recvfrom_netlabel(pulseaudio_t)
-corenet_tcp_sendrecv_generic_if(pulseaudio_t)
-corenet_udp_sendrecv_generic_if(pulseaudio_t)
-corenet_tcp_sendrecv_generic_node(pulseaudio_t)
-corenet_udp_sendrecv_generic_node(pulseaudio_t)
-
-corenet_sendrecv_pulseaudio_server_packets(pulseaudio_t)
 corenet_tcp_bind_pulseaudio_port(pulseaudio_t)
-corenet_tcp_sendrecv_pulseaudio_port(pulseaudio_t)
-
-corenet_sendrecv_soundd_server_packets(pulseaudio_t)
 corenet_tcp_bind_soundd_port(pulseaudio_t)
-corenet_tcp_sendrecv_soundd_port(pulseaudio_t)
-
-corenet_sendrecv_sap_server_packets(pulseaudio_t)
+corenet_tcp_sendrecv_generic_if(pulseaudio_t)
+corenet_tcp_sendrecv_generic_node(pulseaudio_t)
 corenet_udp_bind_sap_port(pulseaudio_t)
-corenet_udp_sendrecv_sap_port(pulseaudio_t)
+corenet_udp_sendrecv_generic_if(pulseaudio_t)
+corenet_udp_sendrecv_generic_node(pulseaudio_t)
+corenet_dontaudit_tcp_connect_xserver_port(pulseaudio_t)
 
 dev_read_sound(pulseaudio_t)
 dev_write_sound(pulseaudio_t)
 dev_read_sysfs(pulseaudio_t)
 dev_read_urand(pulseaudio_t)
 
-files_read_usr_files(pulseaudio_t)
 
+fs_rw_anon_inodefs_files(pulseaudio_t)
 fs_getattr_tmpfs(pulseaudio_t)
-fs_getattr_all_fs(pulseaudio_t)
 fs_list_inotifyfs(pulseaudio_t)
-fs_rw_anon_inodefs_files(pulseaudio_t)
-fs_search_auto_mountpoints(pulseaudio_t)
 
-term_use_all_ttys(pulseaudio_t)
-term_use_all_ptys(pulseaudio_t)
+term_use_all_inherited_ttys(pulseaudio_t)
+term_use_all_inherited_ptys(pulseaudio_t)
 
 auth_use_nsswitch(pulseaudio_t)
 
 logging_send_syslog_msg(pulseaudio_t)
 
-miscfiles_read_localization(pulseaudio_t)
-
-userdom_read_user_tmpfs_files(pulseaudio_t)
+userdom_read_user_tmp_files(pulseaudio_t)
 
 userdom_search_user_home_dirs(pulseaudio_t)
 userdom_write_user_tmp_sockets(pulseaudio_t)
 
 tunable_policy(`use_nfs_home_dirs',`
+	fs_mount_nfs(pulseaudio_t)
+	fs_mounton_nfs(pulseaudio_t)
 	fs_manage_nfs_dirs(pulseaudio_t)
 	fs_manage_nfs_files(pulseaudio_t)
 	fs_manage_nfs_symlinks(pulseaudio_t)
+	fs_manage_nfs_named_sockets(pulseaudio_t)
+	fs_manage_nfs_named_pipes(pulseaudio_t)
 ')
 
 tunable_policy(`use_samba_home_dirs',`
+	fs_mount_cifs(pulseaudio_t)
+	fs_mounton_cifs(pulseaudio_t)
 	fs_manage_cifs_dirs(pulseaudio_t)
 	fs_manage_cifs_files(pulseaudio_t)
 	fs_manage_cifs_symlinks(pulseaudio_t)
+	fs_manage_cifs_named_sockets(pulseaudio_t)
+	fs_manage_cifs_named_pipes(pulseaudio_t)
 ')
 
 optional_policy(`
@@ -153,8 +132,9 @@ optional_policy(`
 
 optional_policy(`
 	dbus_system_domain(pulseaudio_t, pulseaudio_exec_t)
-	dbus_all_session_bus_client(pulseaudio_t)
-	dbus_connect_all_session_bus(pulseaudio_t)
+	dbus_system_bus_client(pulseaudio_t)
+	dbus_session_bus_client(pulseaudio_t)
+	dbus_connect_session_bus(pulseaudio_t)
 
 	optional_policy(`
 		consolekit_dbus_chat(pulseaudio_t)
@@ -174,16 +154,33 @@ optional_policy(`
 ')
 
 optional_policy(`
+	gnome_read_gkeyringd_state(pulseaudio_t)
+	gnome_signull_gkeyringd(pulseaudio_t)
+	gnome_manage_gstreamer_home_files(pulseaudio_t)
+	gnome_exec_gstreamer_home_files(pulseaudio_t)
+')
+
+optional_policy(`
 	rtkit_scheduled(pulseaudio_t)
 ')
 
 optional_policy(`
+	mozilla_plugin_delete_tmpfs_files(pulseaudio_t)
+	mozilla_plugin_read_tmpfs_files(pulseaudio_t)
+')
+
+optional_policy(`
 	policykit_domtrans_auth(pulseaudio_t)
 	policykit_read_lib(pulseaudio_t)
 	policykit_read_reload(pulseaudio_t)
 ')
 
 optional_policy(`
+	systemd_read_logind_sessions_files(pulseaudio_t)
+	systemd_login_read_pid_files(pulseaudio_t)
+')
+
+optional_policy(`
 	udev_read_state(pulseaudio_t)
 	udev_read_db(pulseaudio_t)
 ')
@@ -196,7 +193,11 @@ optional_policy(`
 	xserver_user_x_domain_template(pulseaudio, pulseaudio_t, pulseaudio_tmpfs_t)
 ')
 
-########################################
+optional_policy(`
+	virt_manage_tmpfs_files(pulseaudio_t)
+')
+
+#######################################
 #
 # Client local policy
 #
@@ -210,8 +211,6 @@ delete_files_pattern(pulseaudio_client,
 
 fs_getattr_tmpfs(pulseaudio_client)
 
-corenet_all_recvfrom_unlabeled(pulseaudio_client)
-corenet_all_recvfrom_netlabel(pulseaudio_client)
 corenet_tcp_sendrecv_generic_if(pulseaudio_client)
 corenet_tcp_sendrecv_generic_node(pulseaudio_client)
 
@@ -220,38 +219,33 @@ corenet_tcp_connect_pulseaudio_port(puls
 corenet_tcp_sendrecv_pulseaudio_port(pulseaudio_client)
 
 pulseaudio_stream_connect(pulseaudio_client)
-pulseaudio_manage_home(pulseaudio_client)
-pulseaudio_home_filetrans_pulseaudio_home(pulseaudio_client, dir, ".pulse")
-pulseaudio_home_filetrans_pulseaudio_home(pulseaudio_client, file, ".esd_auth")
-pulseaudio_home_filetrans_pulseaudio_home(pulseaudio_client, file, ".pulse-cookie")
+pulseaudio_manage_home_files(pulseaudio_client)
 pulseaudio_signull(pulseaudio_client)
 
-# TODO: ~/.cache
 userdom_manage_user_home_content_files(pulseaudio_client)
 
-userdom_read_user_tmpfs_files(pulseaudio_client)
-# userdom_delete_user_tmpfs_files(pulseaudio_client)
+userdom_read_user_tmp_files(pulseaudio_client)
 
 tunable_policy(`use_nfs_home_dirs',`
-	fs_getattr_nfs(pulseaudio_client)
-	fs_manage_nfs_dirs(pulseaudio_client)
-	fs_manage_nfs_files(pulseaudio_client)
-	fs_read_nfs_symlinks(pulseaudio_client)
+    fs_getattr_nfs(pulseaudio_client)
+    fs_manage_nfs_dirs(pulseaudio_client)
+    fs_manage_nfs_files(pulseaudio_client)
+    fs_read_nfs_symlinks(pulseaudio_client)
 ')
 
 tunable_policy(`use_samba_home_dirs',`
-	fs_getattr_cifs(pulseaudio_client)
-	fs_manage_cifs_dirs(pulseaudio_client)
-	fs_manage_cifs_files(pulseaudio_client)
-	fs_read_cifs_symlinks(pulseaudio_client)
+    fs_getattr_cifs(pulseaudio_client)
+    fs_manage_cifs_dirs(pulseaudio_client)
+    fs_manage_cifs_files(pulseaudio_client)
+    fs_read_cifs_symlinks(pulseaudio_client)
 ')
 
 optional_policy(`
-	pulseaudio_dbus_chat(pulseaudio_client)
+    pulseaudio_dbus_chat(pulseaudio_client)
 ')
 
 optional_policy(`
-	rtkit_scheduled(pulseaudio_client)
+    rtkit_scheduled(pulseaudio_client)
 ')
 
 optional_policy(`
Index: serefpolicy-contrib-20140730/puppet.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/puppet.fc
+++ serefpolicy-contrib-20140730/puppet.fc
@@ -1,18 +1,20 @@
-/etc/puppet(/.*)?	gen_context(system_u:object_r:puppet_etc_t,s0)
+/etc/puppet(/.*)?			        gen_context(system_u:object_r:puppet_etc_t,s0)
 
-/etc/rc\.d/init\.d/puppet	--	gen_context(system_u:object_r:puppet_initrc_exec_t,s0)
-/etc/rc\.d/init\.d/puppetmaster	--	gen_context(system_u:object_r:puppetmaster_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/puppet	    --	gen_context(system_u:object_r:puppetagent_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/puppetmaster --	gen_context(system_u:object_r:puppetmaster_initrc_exec_t,s0)
 
-/usr/bin/puppetca	--	gen_context(system_u:object_r:puppetca_exec_t,s0)
-/usr/bin/puppetd	--	gen_context(system_u:object_r:puppet_exec_t,s0)
-/usr/bin/puppetmasterd	--	gen_context(system_u:object_r:puppetmaster_exec_t,s0)
-
-/usr/sbin/puppetca	--	gen_context(system_u:object_r:puppetca_exec_t,s0)
-/usr/sbin/puppetd	--	gen_context(system_u:object_r:puppet_exec_t,s0)
-/usr/sbin/puppetmasterd	--	gen_context(system_u:object_r:puppetmaster_exec_t,s0)
-
-/var/lib/puppet(/.*)?	gen_context(system_u:object_r:puppet_var_lib_t,s0)
-
-/var/log/puppet(/.*)?	gen_context(system_u:object_r:puppet_log_t,s0)
-
-/var/run/puppet(/.*)?	gen_context(system_u:object_r:puppet_var_run_t,s0)
+#helper scripts
+/usr/bin/start-puppet-agent       --  gen_context(system_u:object_r:puppetagent_exec_t,s0)
+/usr/bin/start-puppet-master      --  gen_context(system_u:object_r:puppetmaster_exec_t,s0)
+
+/usr/bin/puppetca	        --	gen_context(system_u:object_r:puppetca_exec_t,s0)
+/usr/bin/puppetd	        --	gen_context(system_u:object_r:puppetagent_exec_t,s0)
+/usr/bin/puppetmasterd	    --	gen_context(system_u:object_r:puppetmaster_exec_t,s0)
+
+/usr/sbin/puppetca	        --	gen_context(system_u:object_r:puppetca_exec_t,s0)
+/usr/sbin/puppetd	        --	gen_context(system_u:object_r:puppetagent_exec_t,s0)
+/usr/sbin/puppetmasterd	    --	gen_context(system_u:object_r:puppetmaster_exec_t,s0)
+
+/var/lib/puppet(/.*)?			gen_context(system_u:object_r:puppet_var_lib_t,s0)
+/var/log/puppet(/.*)?			gen_context(system_u:object_r:puppet_log_t,s0)
+/var/run/puppet(/.*)?			gen_context(system_u:object_r:puppet_var_run_t,s0)
